Summary: A BitCoin miner
Name: bfgminer
Version: 3.3.0
Release: 1%{?dist}
Group: Applications/Internet
License: GPLv3 and MIT
URL: https://github.com/luke-jr/bfgminer
Source0: http://luke.dashjr.org/programs/bitcoin/files/bfgminer/%{version}/%{name}-%{version}.tbz2
Patch1: bfgminer-3.3.0-configure.patch
Patch2: bfgminer-3.3.0-privs.patch
# Some software is bundled:
# ADL/ files are writteb by luke-jr+redhatbugs@utopios.org
# CL/ fukse are tge official OpenCL 1.0 headers - opencl-headers causes failure
# lib/ is gnulib snippets, allowed to be bundled as per:
#      https://fedorahosted.org/fpc/ticket/174
# libblkmaker/  could be decoupled into its own library, the configure
#               command accepts --with-system-libblkmaker for such a case
# Our devel package only contains libblkmaker headers and would than not be needed anymore
Provides: bundled(gnulib)

BuildRequires: libcurl-devel libusb-devel libudev-devel ncurses-devel
BuildRequires: jansson-devel libtool uthash yasm
BuildRequires: chrpath

# BuildRequires: opencl-headers
Requires: pkgconfig

%description
This is a multi-threaded multi-pool FPGA, GPU and CPU miner with ATI GPU
monitoring, (over)clocking and fanspeed support for bitcoin and derivative
coins.

%package devel
Summary: Development library and include files for bfgminer
Group: Development/Libraries
Requires: %{name}%{?_isa} = %{version}-%{release}

%description devel
The devel package contains the library and include files.

%prep
%setup -q
# TODO: use opencl-headers instead - currently fails to compile
#rm -rf CL
#ln -s /usr/include/CL

%patch1 -p1
%patch2 -p1

%build
%configure --enable-cpumining --enable-scrypt --disable-rpath --disable-static
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libblkmaker/libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libblkmaker/libtool

make %{?_smp_mflags} CFLAGS="$RPM_OPT_FLAGS"
cp ./libblkmaker/COPYING COPYING_libblkmaker

%install

%makeinstall INSTALLCMD='install -p' INSTALLMAN='install -p'
rm $RPM_BUILD_ROOT%{_libdir}/*.la
rm -r $RPM_BUILD_ROOT%{_docdir}/bfgminer
rm api-example.o

%files
%doc LICENSE COPYING_* 
#doc ./bitstreams/COPYING_ztex ./bitstreams/COPYING_fpgaminer
%doc COPYING_libblkmaker NEWS README README.* AUTHORS HACKING
%doc example.conf api-example.*
%{_bindir}/bfgminer
%{_bindir}/bfgminer-rpc
%{_bindir}/bitforce-firmware-flash
%{_libdir}/libblkmaker*.so.*
%dir %{_datadir}/bfgminer
# these are firmware binary blobs
#%{_datadir}/bfgminer/bitstreams/*.b*
%dir %{_datadir}/bfgminer
%{_datadir}/bfgminer/opencl/*.cl

%files devel
%dir %{_includedir}/libblkmaker-0.1
%{_includedir}/libblkmaker-0.1/*.h
%{_libdir}/libblkmaker-0.1.so
%{_libdir}/libblkmaker_jansson-0.1.so
%{_libdir}/pkgconfig/libblkmaker_jansson-0.1.pc

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%changelog
* Tue Oct 22 2013 Paul Wouters <pwouters@redhat.com> - 3.3.0-1
- Updated to 3.3.0
- Fix rpath with patchlet and sed
- Fix missing-call-to-setgroups-before-setuid in bfgminer
- Fix missing-call-to-chdir-with-chroot in bfgminer

* Tue Oct 22 2013 Paul Wouters <pwouters@redhat.com> - 3.1.3-3
- Remove rpaths in libraries and binaries

* Mon Oct 21 2013 Paul Wouters <pwouters@redhat.com> - 3.1.3-2
- Fixed version number in changelog
- Removed accidental install of api-example.o
- Run ldconfig in post and postun
- Make devel depend on arch

* Fri Jul 26 2013 Paul Wouters <pwouters@redhat.com> - 3.1.3-1
- Initial package
